#!/usr/bin/perl
#============================================================================#
# Program Name - Sepal's SPOX v2.0                                           # 
# Programer - Kim se youn (madgf@hanmail.net, sepal@spfamily.com)            #
# Homepage - http://sepal.woorizip.com or http://www.spfamily.com			 #
# Last Modified - 2001.02.24                                                 #
#                                                              made in Korea #
#============================================================================#

##############################################################################
$main_dir = "./";               #data丮 ִ° 
$cgi_url = "http://203.237.210.235/manduk06/spox/ox.cgi";           #ox.cgi URL
$img_url = "http://203.237.210.235/manduk06/spox/img";              #img丮 URL
$sendmail = "/usr/lib/sendmail"; #sendmail ġ
##############################################################################

umask(000);
&parse;

sub parse{
	if($ENV{'REQUEST_METHOD'} eq "GET") {
		$buffer = $ENV{'QUERY_STRING'};
    } 
	else {
        read( STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
    }

    @pairs = split(/&/,$buffer);

	foreach $pair( @pairs ) {
        my($name,$value)=split(/=/,$pair);
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
		$value =~ s/<([^>]|\n)*>//g; #html   ... 
	
        $FORM{$name} = $value;
    }

	&select_action;
}

sub select_action {
	my $act = $FORM{'action'};
	local $data_dir = "$main_dir/data";
	if(-e "$data_dir/conf.cgi") {
		&get_conf;
		if($act eq "") {
			&display;
		}
		else {
			&{$act};
		}
	}
	else{
		if($act eq "") {
			&first_connect;
		}
		else {
			&{$act};
		}
	}	
}

sub get_conf {
	open(CONF, "$data_dir/conf.cgi");
	foreach (<CONF>){
		if (/(\w+)\s*=\s*(.*?)\s*$/){
			$CONF{$1} = $2;
		}
	}
	close(CONF);
}

sub display {
	local $num_data;
	$num_data = $FORM{'num_data'};
	if($num_data eq ""){
		open(NUM, "$data_dir/num.txt");
		chomp($num_data = <NUM>);
		close(NUM);
	}
	
	&make_data unless($num_data);

	&head("SPOX v2.0");
	print <<__BTN__;	
		<form method=post action=$cgi_url >
		<input type=hidden name=action value="view_list">
		<input type=submit value="Ʈ  " style='background-color:9bffcc;border:1 solid green;height:20'>
		</form>
__BTN__
	&call_title;	

	my($cnt_data, @ox_cnt, $total_width);
	local($o_cnt, $x_cnt);
	open(CNT, "$data_dir/$num_data/cnt.txt");
	chomp($cnt_data = <CNT>);
	close(CNT);
	
	@ox_cnt = split(/\|/, $cnt_data);
	$o_cnt = ($ox_cnt[0]) ? $ox_cnt[0] : 0;
	$x_cnt = ($ox_cnt[1]) ? $ox_cnt[1] : 0;
	$total_width = 150;
	if($o_cnt == 0 && $x_cnt == 0) {
		$o_length = 5;
		$x_length = 5;
		$o_per = 0;
		$x_per = 0;
	}
	else{
		$o_per = $o_cnt/($o_cnt + $x_cnt);
		$x_per = $x_cnt/($o_cnt + $x_cnt);
		$o_length = $o_per*$total_width;
		$x_length = $x_per*$total_width;	
	}
	$o_per *= 100;
	$x_per *= 100;
	$o_per = sprintf("%.2f", $o_per);
	$x_per = sprintf("%.2f", $x_per);
	
	print <<__CNT__;
		<br>
		<table width=560 border=0 cellpadding=0 cellspacing=0 style="filter:alpha(opacity=67)">
			<tr>
				<td width=280 align=right> $o_cnt <font color=#354078>($o_per %)</font> <img src=$img_url/o.gif width=$o_length height=10></td>
				<td width=280><img src=$img_url/x.gif width=$x_length height=10> ݴ $x_cnt <font color=#354078>($x_per %)</font></td>
			</tr>
		</table>
__CNT__

	print <<__BTN__;
		<br>
		<table border=0 cellpadding=0 cellspacing=0 width=300 style="filter:alpha(opacity=67)">
			<tr>
				<td align=center>
				<form method=post action=$cgi_url>
				<input type=hidden name=action value="input_form">
				<input type=hidden name=chanban value="o">
				<input type=hidden name=num_data value="$num_data">
				<input type=submit value="ǰ " style='background-color:skyblue;border:1 solid blue;height:20'>
				</form>
				</td>
				<td align=center>
				<form method=post action=$cgi_url>
				<input type=hidden name=action value="input_form">
				<input type=hidden name=chanban value="x">
				<input type=hidden name=num_data value="$num_data">
				<input type=submit value="ݴǰ " style='background-color:pink;border:1 solid hotpink;height:20'>
				</form>	
				</td>
			</tr>
		</table>
__BTN__
	&view_ox("$num_data");
	&foot;
}

sub view_ox {
	my($num_data, $list_num, $article_num, $page, $total_num, $total_page, $start_num, $end_num);
	$num_data = shift;
	
	$total_num = ($o_cnt > $x_cnt) ? $o_cnt : $x_cnt;
	$article_num = $o_cnt + $x_cnt;
	$list_num = 10;
	$page = $FORM{'page'};
	$page ||= 1;
	$total_page = int(($total_num-1)/$list_num) + 1;
	$start_num = $list_num*($page-1);
	$start_num = 0 if($start_num < 0);
	$end_num = $start_num + $list_num -1;	

	print "<table width=600 border=0 cellpadding=3 cellspacing=0><tr>";
	print "<Tr><td colspan=2 align=center>Total $article_num articles ($page/$total_page page)</td></tr>\n";
	for(1..2) {
		print "<td width=300 valign=top>";
		my($ox, $ox_name, @num_data, $idx_num);
		if($_ == 1) {
			$ox = "o";
			$ox_name = "";
			$ox_col01 = "skyblue";
			$ox_col02 = "white";
		}
		else {
			$ox = "x";
			$ox_name = "ݴ";
			$ox_col01 = "pink";
			$ox_col02 = "white";
		}
#		opendir(DIR, "$data_dir/$num_data/$ox");
#		@num_data =  grep(!/^\.{1,2}$/, readdir(DIR));	#Ÿ ȣ ... ^.^
#		closedir(DIR);
		open(IDX, "$data_dir/$num_data/$ox.idx");
		chomp(@num_data = <IDX>);
		close(IDX);
#		$idx_num = @num_data;
#		@num_data = sort {($b <=> $a) || ($a cmp $b)} @num_data;

		for($start_num..$end_num) {
			my($gul_data, @gul_list, $name, $email, $subject, $comment, $date_val);
			last unless("$num_data[$_]");
			open(GUL, "$data_dir/$num_data/$ox/$num_data[$_]");
			$gul_data = <GUL>;
			close(GUL);
			@gul_list = split(/\|/, $gul_data);
			$name = $gul_list[0];
			$email = $gul_list[1];
			$subject = $gul_list[2];
			$subject = "<img src=$img_url/new.gif width=17 height=10> ".$subject if(-M "$data_dir/$num_data/$ox/$num_data[$_]" < 1.0);
			$comment = $gul_list[3];
			if($comment !~ /[\xA1-\xFE]/){ #ѱ ƴҰ wrap ų ^^
				$comment =~ s/(.{1,41})/$1<br>/g;
			}
			$date_val = $gul_list[4];
			$name = "<a href=mailto:$email title=$email><img src=$img_url/mail.gif width=14 height=10 border=0 alt=\"$email\"> $name</a>"if($email);
			print <<__TABLE__;
				<table border=1 cellpadding=2 cellspacing=0 width=100% bgcolor=$ox_col02 bordercolordark=white bordercolorlight=green style="filter:alpha(opacity=67)">
					<tr bgcolor=$ox_col01>
						<td>
							<table border=0 cellpadding=0 cellspacing=0 width=100% >
								<tr>
									<!--<td width=40><font color=$ox_col02> 222$idx_num</font></td>-->
									<td><font color=red>$subject</font></td>
									<td width=23 align=right>
										<a href=$cgi_url?action=input_pwd&call_act=mod_form&ox=$ox&num_data=$num_data&gul_data=$num_data[$_] title="ϱ"><font color=red size=3><b>+</b></font></a> 
										<a href=$cgi_url?action=input_pwd&call_act=del_data&ox=$ox&num_data=$num_data&gul_data=$num_data[$_] title="ϱ"><font color=red size=3><b>-</b></font></a>
									</td>
								</tr>
							</table>
						</td>
					</tr>
					<tr><td>		
						<table border=0 width=100% cellpadding=1 cellspacing=0>
						<tr><td align=right><font color=blue>$name</font> $ox_name ǰ</td></tr>
						<tr><td class=cont><font color=green>$comment</font></td></tr>
						<tr><td align=right><font color=red>$date_val</font></td></tr>
						</table>
					</td></tr>
				</table><br>
__TABLE__
#			$idx_num--;				
		}
		print "</td>";
	}
	print "</tr></table>";
	&pagemove("$page", "$total_page");
}

sub view_list {
	my($page, $list_num, $total_num, $total_page, $title_data, @title_list, $title, $date, $cnt_data, @cnt, $o_cnt, $x_cnt);
	open(NUM, "$data_dir/num.txt");
	chomp($total_num = <NUM>);
	close(NUM);
	$list_num = 10;
	$page = $FORM{'page'};
	$page ||= 1;
	$total_page = int(($total_num-1)/$list_num) + 1;
	$start_num = $total_num - $list_num*($page) + 1;
	$end_num = $start_num + $list_num -1;

	&head(" Ʈ ");
	print "<br><br><br>Total $total_num subjects ($page/$total_page page)\n";
	print "<table border=1 width=550 cellpadding=3 cellspacing=0 bgcolor=#ffffff bordercolordark=white bordercolorlight=bule >\n";
	print "<tr bgcolor=hotpink><td align=center><font color=white></font></td><td align=center><font color=white></font></td><td align=center><font color=white> &nbsp;&nbsp;&nbsp;&nbsp; </font></td><td align=center><font color=white></font></td><td align=center><font color=white></font></td><td align=center><font color=white>&nbsp;&nbsp;¥</font></td></tr>\n";
	for($i=$end_num; $i >= $start_num; $i--) {
		last unless(-d "$data_dir/$i");
		open(DATA, "$data_dir/$i/title.txt");
		chomp($title_data = <DATA>);
		close(DATA);
		@title_list = split(/\|/, $title_data);
		$title = $title_list[0];
		$date = $title_list[2];
		open(CNT, "$data_dir/$i/cnt.txt");
		chomp($cnt_data = <CNT>);
		close(CNT);
		@cnt = split(/\|/, $cnt_data);
		$o_cnt = $cnt[0];
		$x_cnt = $cnt[1];
		$o_cnt ||= 0;
		$x_cnt ||= 0;
		print "<tr><td align=center>$i</td><td width=16><img src=$img_url/text.gif width=16 height=16 border=0></td>";
		print "<td><a href=$cgi_url?num_data=$i>$title</a></td>";
		print "<td width=25 align=right><font color=blue>$o_cnt</font></td><td width=25 align=right><font color=red>$x_cnt</font></td>";
		print "<td width=62 align=right>$date</td></tr>\n"; 
	}
	print "</table>\n";
	print "<br>\n";
	&pagemove("$page", "$total_page");
	&foot;
}

#===================================  ̵ Լ ^.^  
sub pagemove{
	my($page, $total_page) = @_;
	my ($sel_col, $font_col, $interval, $start, $end, $prev, $next, $next_opt, $first, $last);
	$sel_col = "#81175B";
	$font_col = "#345081";

	print "<div align=center><table border=0 cellpadding=0 cellspacing=0>";
	print "<tr><td align=center class=ver9><font color=$font_col>";
	$interval = 10; 
	$start = (int(($page-1)/$interval))*$interval + 1;
	$end = $start + $interval -1;

	if($total_page <= $end){
		$end = $total_page;
		$next_opt = "no"
	}

	if($start == 1){
		print "[]...";
	}
	else{
		$prev = $start - 1;
		print "[<a href=$cgi_url?action=$FORM{'action'}&num_data=$num_data&page=1><font color=$font_col>First</font></a>]";
		print "[<a href=$cgi_url?action=$FORM{'action'}&num_data=$num_data&page=$prev><font color=$font_col></font></a>]...";
	}
	
	for($start..$end){
		if($page eq $_){
			print "[<font color=$sel_col><b>$_</b></font>]";
		}
		else{
			print "[<a href=$cgi_url?action=$FORM{'action'}&num_data=$num_data&page=$_><font color=$font_col>$_</font></a>]";
		}
	}

	if($next_opt eq "no"){
		print "...[]";
	}
	else{
		$next = $end + 1;
		print "...[<a href=$cgi_url?action=$FORM{'action'}&num_data=$num_data&page=$next><font color=$font_col></font></a>]";
		print "[<a href=$cgi_url?action=$FORM{'action'}&num_data=$num_data&page=$total_page><font color=$font_col>Last</font></a>]";
	}
	print "</font></td></tr>\n";
	print "</table></div>\n";
	print "<br><a href=$cgi_url?&action=display&num_data=$FORM{'num_data'}><img src=$img_url/admin.gif width=21 height=13 alt=\" ..\" border=0></a>\n";
}

sub call_title {
	my($recent_dir, $title_data, @title_list, $title, $comment, $date_val);
	$recent_dir = $num_data;

	open(DATA, "$data_dir/$recent_dir/title.txt");
	chomp($title_data = <DATA>);
	close(DATA);
	
	@title_list = split(/\|/, $title_data);
	$title = $title_list[0];
	$comment = $title_list[1];
	$date_val = $title_list[2];

	print <<__TITLE__;
		<table border=1 width=500 cellpadding=3 cellspacing=0 bgcolor="#8BC4FD" bordercolorlight=blue bordercolordark=white style="filter:alpha(opacity=67)"> 
			<tr><td width=47 align=center><font color=#ffffff> &nbsp; </font></td>
				<td>
					<table border=0 width=100% cellpadding=0 cellspacing=0>
						<tr>
							<td><font color=#ffffff>$title</font></td>
							<td align=right><a href=$cgi_url?action=input_pwd&call_act=mod_title&num_data=$num_data><img src=$img_url/modify.gif width=13 height=13 border=0 alt=" ϱ ^^"></a></td>
						</tr>
					</table>
				</td>
			</tr>
			<tr bgcolor="#ffffff">
				<td align=center> &nbsp; </td>
				<td>
					<table border=0 cellpadding=0 cellspacing=0 width=100%>
						<tr><td>$comment</td></tr>
						<tr><td align=right><font color=#354078>$date_val</font></td></tr>
					</table>
				</td>
			</tr>
		</table>
__TITLE__

}

sub input_form {
	local $num_data = $FORM{'num_data'};

	&head("SPOX v2.0");
	print "<br><br>";
	&call_title;
	my($ox);
	if($FORM{'chanban'} eq "o") {
		$ox = "";
	}
	else{
		$ox = "ݴ";
	}
	print <<__INPUT__;
	<!---------[ ĭ üũ ڹٽũƮ ]------------>
		<script language="JavaScript">
			function sendit()
			{
				var str;
				
				str = document.register.name.value;
				if(str == ""){
					alert("ۼ ̸ Ȯϰ Էּ...");
					document.register.name.focus();
					return true;
				}

				str = document.register.subject.value;
				if(str == ""){
					alert(" Էּ...");
					document.register.subject.focus();
					return true;
				}

				str = document.register.comment.value;
				if(str == "" || str == "html±״  ʽϴ..."){
					alert(" Է ּ...");
					document.register.comment.focus();
					return true;
				}
				
				document.register.submit();
				return true;
			}

			function clearField(field){
				if (field.value == field.defaultValue) {
					field.value = "";
				}
			}
			
			function checkField(field){
				if (field.value == "") {
					field.value = field.defaultValue;
				}
			}
		</script>		
		<form method=post action=$cgi_url name=register onSubmit="sendit();return false">
		<input type=hidden name=chanban value="$FORM{'chanban'}">
		<input type=hidden name=num_data value="$num_data">
		<input type=hidden name=action value="write_data">
		<table border=0 width=400 cellpadding=3 cellspacing=0 style="filter:alpha(opacity=67)">
		<tr><td> &nbsp; &nbsp; </td><td><input type=text name=name size=51 class=input maxlength=32></td></tr>
		<tr><td>  </td><td><input type=text name=email size=51 class=input></td></tr>
		<tr><td> &nbsp; &nbsp; </td><td><input type=text name=subject size=51 class=input maxlength=32></td></tr>
		<tr><td>$oxǰ</td><td><textarea name=comment cols=50 rows=8 class=textarea onBlur="checkField(this)" onFocus="clearField(this)">html±״  ʽϴ...</textarea></td></tr>			
		<tr><td>йȣ</td><td><input type=password name=pwd size=12 class=input>  ǰ ,  ʿմϴ.</td></tr>
		<tr><td>&nbsp;</td><td><input type=submit value=" $ox ǰ  " style='background-color:skyblue;border:1 solid blue;height:20'> <input type=reset value="             " style='background-color:pink;border:1 solid hotpink;height:20'></td></tr>
		</table>
		</form>
		<a href=$cgi_url?&action=display&num_data=$num_data><img src=$img_url/list.gif border=0 alt=" "></a>
__INPUT__
	&foot;
}

sub write_data {
	my($ox, $gul_num, $cnt_data, @ox_cnt, $o_cnt, $x_cnt, @idx_list, @idx);
	local $num_data = $FORM{'num_data'};
	$ox = $FORM{'chanban'};
	open(CNT, "$data_dir/$num_data/cnt.txt");
	chomp($cnt_data = <CNT>);
	close(CNT);

	@ox_cnt = split(/\|/, $cnt_data);
	$o_cnt = ($ox_cnt[0]) ? $ox_cnt[0] : 0;
	$x_cnt = ($ox_cnt[1]) ? $ox_cnt[1] : 0;
	if($ox eq "o") {
		$o_cnt++;
	}
	else {
		$x_cnt++;
	}

	&lock;
	open(CNT, ">$data_dir/$num_data/cnt.txt");
	print CNT "$o_cnt|$x_cnt";
	close(CNT);	
	&unlock;
	$FORM{'comment'} =~ s/\r?\n/<br>/g;
	&get_date;
	my $pwd = crypt($FORM{'pwd'}, "sp"); 

	open(IDX, "$data_dir/$num_data/$ox.idx");
	chomp(@idx = <IDX>);
	close(IDX);
	$gul_num = $idx[0] + 1;
	&lock;
	open(DATA, ">$data_dir/$num_data/$ox/$gul_num");
	print DATA "$FORM{'name'}|$FORM{'email'}|$FORM{'subject'}|$FORM{'comment'}|$date_val|$pwd";
	close(DATA);
	&unlock;
	
	#ε ϱ... ^.^
	open(IDX, "$data_dir/$num_data/$ox.idx");
	@idx_list = <IDX>;
	close(IDX);
	&lock;
	open(IDX, ">$data_dir/$num_data/$ox.idx");
	print IDX "$gul_num\n";
	print IDX @idx_list;
	close(IDX);
	&unlock;

	&load_page("$num_data");
}

sub load_page{
	my($num_data, $load_url);
	$num_data = shift;
	$load_url = "$cgi_url?action=display&num_data=$num_data";
	&head;
	print "<META HTTP-EQUIV=Refresh CONTENT=1;URL=$load_url>\n";
	print "<p>&nbsp;<p>&nbsp;<p>&nbsp;<hr width=300 color=$CONF{'head_color'}>\n";
	print "<font class=ver9>Loading ......</font>\n";
	print "<hr width=300  color=$CONF{'head_color'}>\n";
	print "<br><br><a href=$load_url><font color=#FFA8E3></font><font color=#92B8FF></font> <font class=ver9> ư</font></a><p>\n" if($FORM{'simple'} ne "yes");
	&foot;
}

sub first_connect {
	&head("SPOX v2.0 Ű ȯմϴ... ^.^");
	print <<__WELCOME__;
			<br><br><br><br>
			<font color=#29487F>
			ó ϼ̳׿...<br><br>
			SPOX v2.0 Ű ȯմϴ... ^.^
			</font>
			<br><br>
			<form method=post action=$cgi_url>
			<input type=hidden name=action value=make_pwd>
			<div align=center>
			<table border=1 cellpadding=5 cellspacing=0 bgcolor=pink bordercolordark=white bordercolorlight=#29487F>
				<tr>
					<td class=cont>
					  <font color=#ffffff>
					   ҽ Ͽ... <br>
					   α׷ (Open)ҽԴϴ.  α׷ ·   մϴ.<br>
					  ҽ ü ܵ ϸ ʿѺκ(Լ, ) ̿ϼŵ ϴ.<br>
					  ҽ ؼ ϴ°  Ͻ  ݵ   ž մϴ.
					  </font>
					  <p align=center>
						<input type=submit value=" ׿ Ǹ մϴ..." style='background-color:9bffcc;border:1 solid green;height:20'>		
					  <br><br>
					</td>
				</tr>
			</table>
			</div>
			</form>

__WELCOME__
	&foot;
}

sub make_pwd {
	&head("ʱ йȣ Է ּ... ^.^");
	print <<__MAKE_PWD__;
		<script language="JavaScript">
		function sendit()
		{
			var str;
			
			str = document.admin.admin_pwd.value;
			if(str == ""){
				alert("  ּ...");
				document.admin.admin_pwd.focus();
				return true;
			}

			document.admin.submit();
			return true;
		}
		</script>
			<br><br><br><br>
			<font color=blue>
			SPOX v2.0 Ű ȯմϴ... ^.^
			</font>
			<br><br>
			<form method=post action=$cgi_url name=admin onSubmit="sendit();return false">
			<input type=hidden name=action value=write_conf>
			<div align=center>
			<table border=1 cellpadding=5 cellspacing=0 bgcolor=skyblue bordercolordark=white bordercolorlight=blue>
				<tr>
					<td class=cont>
					  <font color=#ffffff>
					  ʱ йȣ  ּ... <br>
					  ⼭ Ͻ ȣ  йȣ ˴ϴ... ^.^<br>
					  </font>
					  <p align=center>
						<input type=password size=17 name=admin_pwd> <input type=submit value="    Ȯ        " style='background-color:hotblue;border:1 solid blue;height:20'>		
					  <br><br>
					</td>
				</tr>
			</table>
			</div>
			</form>

__MAKE_PWD__
	&foot;
}

sub write_conf {
	if(-e "$data_dir/conf.cgi") {
		&error("haker");
	}
	else {
		my $admin_pwd = crypt($FORM{'admin_pwd'},"sp");
		open  (CONF, ">$data_dir/conf.cgi");
		print CONF "admin_pwd = $admin_pwd";
		close (CONF);
		&input_pwd;
	}
}

sub input_pwd {
	my($call_act, $t_msg, $msg, $hidden);
	$call_act = $FORM{'call_act'} ? "$FORM{'call_act'}" : "admin_ok";

	if($call_act eq "admin_ok") {
		$t_msg = "  ϼ̳׿...<br><br>SPOX v2.0 Ű ȯմϴ... ^.^";
		$msg = " йȣ ֽð Ȯιư ּ... ^.^";
	}
	elsif($call_act eq "mod_form") {
		$t_msg = " ǰ մϴ...";
		$msg = " ۼ йȣ ֽð Ȯιư ּ... ^.^";
		$hidden = "<input type=hidden name=ox value=$FORM{'ox'}><input type=hidden name=num_data value=$FORM{'num_data'}><input type=hidden name=gul_data value=$FORM{'gul_data'}>";
	}
	elsif($call_act eq "del_data") {
		$t_msg = " ǰ մϴ...";
		$msg = " ۼ йȣ ֽð Ȯιư ּ... ^.^";
		$hidden = "<input type=hidden name=ox value=$FORM{'ox'}><input type=hidden name=num_data value=$FORM{'num_data'}><input type=hidden name=gul_data value=$FORM{'gul_data'}>";
	}
	elsif($call_act eq "mod_title"){
		$t_msg = " մϴ...";
		$msg = " йȣ ֽð Ȯιư ּ... ^.^";
		$hidden = "<input type=hidden name=num_data value=$FORM{'num_data'}>";	
	}
	else{
		&error("haker");
	}

	&head("йȣ Է ּ.");

	print <<__INPUT_PWD__;
		<br><br><br><br>
		<script language="JavaScript">
		function sendit()
		{
			var str;
			
			str = document.admin.admin_pwd.value;
			if(str == ""){
				alert("Ȯ йȣ ּ...");
				document.admin.admin_pwd.focus();
				return true;
			}

			document.admin.submit();
			return true;
		}
		</script>
			<font color=#29487F>$t_msg</font>
			<br><br>
			<form method=post action=$cgi_url name=admin onSubmit="sendit();return false">
			<input type=hidden name=action value=$call_act>
			$hidden
			<div align=center>
			<table border=1 cellpadding=5 cellspacing=0 bgcolor=pink bordercolordark=white bordercolorlight=hotpink>
				<tr>
					<td class=cont>
					  <font color=#ffffff>
					  ںйȣ  ּ... <br>
					  $msg<br>
					  </font>
					  <p align=center>
						<input type=password size=17 name=admin_pwd> <input type=submit value="    Ȯ        " style='background-color:pink;border:1 solid hotpink;height:20'>		
					  <br><br>
					</td>
				</tr>
			</table>
			</div>
			</form>
		<a href=$cgi_url?&action=display&num_data=$FORM{'num_data'}><img src=$img_url/list.gif border=0  alt=" "></a>
__INPUT_PWD__

	&foot;
}

sub mod_title {
	my($pwd, $data, @list, $title, $comment, $date_val);
	$pwd = crypt($FORM{'admin_pwd'}, "sp");
	if($pwd eq $CONF{'admin_pwd'}){
		print "Set-Cookie: ADMIN_PWD=$pwd;\n";
		open(DATA, "$data_dir/$FORM{'num_data'}/title.txt");
		chomp($data = <DATA>);
		close(DATA);
		@list = split(/\|/, $data);
		$title = $list[0];
		$comment = $list[1];
		$date_val = $list[2];
		$comment =~ s/<br>/\n/g;
		&head("  Ÿ  ");
		
		print <<__MAKE_DATA__;
			<br><br><br><br>
			<script language="JavaScript">
			function sendit()
			{
				var str;
				
				str = document.make_data.title.value;
				if(str == ""){
					alert("  ּ...");
					document.make_data.title.focus();
					return true;
				}
				
				str = document.make_data.comment.value;
				if(str == ""){
					alert("   ּ...");
					document.make_data.comment.focus();
					return true;
				}


				document.make_data.submit();
				return true;
			}
			</script>
				<font color=#29487F>
				п ǰ ִ   ּ... ^.^<br>
				</font>
				<br><br>
				<form method=post action=$cgi_url name=make_data onSubmit="sendit();return false">
				<input type=hidden name=action value=modify_title>
				<input type=hidden name=num_data value=$FORM{'num_data'}>
				<input type=hidden name=date_val value=$date_val>
				<div align=center>
				<table border=1 cellpadding=5 cellspacing=0 bgcolor=#29487F bordercolordark=white bordercolorlight=#29487F>
					<tr><td class=cont><font color=#ffffff> </font></td><td><input type=text name=title value="$title" size=49></td></tr>
					<tr><td class=cont><font color=#ffffff> </font></td><td><textarea  name=comment cols=47 rows=7>$comment</textarea></td></tr>
					<tr><td>&nbsp;</td><td><input type=submit value="                        "></td></tr>
				</table>
				</div>
				</form>

__MAKE_DATA__

	
	}
	else{
		&error("pwd");
	}
}

sub modify_title {
	&read_cookie;
	&error("haker") if($COOKIE{'ADMIN_PWD'} ne $CONF{'admin_pwd'});
	
	$FORM{'comment'} =~ s/\r?\n/<br>/g;
	open(TITLE, ">$data_dir/$FORM{'num_data'}/title.txt");
	print TITLE "$FORM{'title'}|$FORM{'comment'}|$FORM{'date_val'}";
	close(TITLE);

	&load_page("$FORM{'num_data'}");

}

sub mod_form {
	my($gul, @gul_data, $name, $email, $subject, $comment, $date_val, $pwd, $org_pwd);
	local $num_data = $FORM{'num_data'};
	open(GUL, "$data_dir/$FORM{'num_data'}/$FORM{'ox'}/$FORM{'gul_data'}");
	$gul = <GUL>;
	close(GUL);
	@gul_data = split(/\|/, $gul);
	$name = $gul_data[0];
	$email = $gul_data[1];
	$subject = $gul_data[2];	
	$comment = $gul_data[3];
	$comment =~ s/<br>/\n/g;
	$date_val = $gul_data[4];
	$org_pwd = $gul_data[5];
	$pwd = crypt($FORM{'admin_pwd'}, "sp");
	if(($pwd eq $org_pwd) || ($pwd eq $CONF{'admin_pwd'})) {
		&head("SPOX v2.0");
		print "<br><br>";
		&call_title;
		my($ox);
		if($FORM{'ox'} eq "o") {
			$ox = "";
		}
		else{
			$ox = "ݴ";
		}
		print <<__INPUT__;
		<!---------[ ĭ üũ ڹٽũƮ ]------------>
			<script language="JavaScript">
				function sendit()
				{
					var str;
					
					str = document.register.name.value;
					if(str == ""){
						alert("ۼ ̸ Ȯϰ Էּ...");
						document.register.name.focus();
						return true;
					}

					str = document.register.subject.value;
					if(str == ""){
						alert(" Էּ...");
						document.register.subject.focus();
						return true;
					}

					str = document.register.comment.value;
					if(str == ""){
						alert(" Է ּ...");
						document.register.comment.focus();
						return true;
					}
					
					document.register.submit();
					return true;
				}
			</script>		
			<form method=post action=$cgi_url name=register onSubmit="sendit();return false">
			<input type=hidden name=ox value="$FORM{'ox'}">
			<input type=hidden name=num_data value="$num_data">
			<input type=hidden name=action value="mod_data">
			<input type=hidden name=gul_data value="$FORM{'gul_data'}">
			<input type=hidden name=date_val value="$date_val">
			<input type=hidden name=pwd value="$pwd">
			<table border=0 width=400 cellpadding=3 cellspacing=0 >
			<tr><td> &nbsp; &nbsp; </td><td><input type=text name=name size=51 value="$name" class=input maxlength=32></td></tr>
			<tr><td>  </td><td><input type=text name=email size=51 value="$email" class=input></td></tr>
			<tr><td> &nbsp; &nbsp; </td><td><input type=text name=subject size=51 value="$subject" class=input maxlength=32></td></tr>
			<tr><td>$oxǰ</td><td><textarea name=comment cols=50 rows=8 class=textarea>$comment</textarea></td></tr>			
			<tr><td>&nbsp;</td><td><input type=submit value="             "> <input type=reset value="             "></td></tr>
			</table>
			</form>
			<a href=$cgi_url?&action=display&num_data=$num_data><img src=$img_url/list.gif border=0  alt=" "></a>
__INPUT__
		&foot;
	}
	else{
		&error("pwd");
	}
}

sub mod_data {
	my($pwd, $gul, @gul_data, $org_pwd, $comment);

	open(GUL, "$data_dir/$FORM{'num_data'}/$FORM{'ox'}/$FORM{'gul_data'}");
	$gul = <GUL>;
	close(GUL);
	@gul_data = split(/\|/, $gul);
	$org_pwd = $gul_data[5];
	$pwd = $FORM{'pwd'};
	$comment = $FORM{'comment'};
	$comment =~ s/\r?\n/<br>/g;
	if($pwd eq $org_pwd || $pwd eq $CONF{'admin_pwd'}) {
		&lock;
		open(GUL, ">$data_dir/$FORM{'num_data'}/$FORM{'ox'}/$FORM{'gul_data'}");
		print GUL "$FORM{'name'}|$FORM{'email'}|$FORM{'subject'}|$comment|$FORM{'date_val'}|$org_pwd";
		close(GUL);
		&unlock;
	}
	else{
		&error("haker");	
	}
	&load_page("$FORM{'num_data'}");
}

sub del_data{
	my($gul, @gul_data, $pwd, $org_pwd, @idx, $cnt, @cnt_data, $o_cnt, $x_cnt);
	$pwd = crypt($FORM{'admin_pwd'}, "sp");
	local $num_data = $FORM{'num_data'};
	open(GUL, "$data_dir/$num_data/$FORM{'ox'}/$FORM{'gul_data'}");
	chomp($gul = <GUL>);
	close(GUL);
	@gul_data = split(/\|/, $gul);
	$org_pwd = $gul_data[5];
	if($pwd eq $org_pwd || $pwd eq $CONF{'admin_pwd'}) {
		unlink("$data_dir/$num_data/$FORM{'ox'}/$FORM{'gul_data'}");
		open(IDX, "$data_dir/$num_data/$FORM{'ox'}.idx");
		chomp(@idx = <IDX>);
		close(IDX);
		
		&lock;
		open(IDX, ">$data_dir/$num_data/$FORM{'ox'}.idx");
		foreach (@idx) {
			print IDX "$_\n" unless($_ eq $FORM{'gul_data'});
		}
		close(IDX);
		&unlock;

		open(CNT, "$data_dir/$num_data/cnt.txt");
		$cnt = <CNT>;
		close(CNT);
		@cnt_data = split(/\|/, $cnt);
		$o_cnt = $cnt_data[0];
		$x_cnt = $cnt_data[1];
		$o_cnt-- if($FORM{'ox'} eq "o");
		$x_cnt-- if($FORM{'ox'} eq "x");
		&lock;
		open(CNT, ">$data_dir/$num_data/cnt.txt");
		print CNT "$o_cnt|$x_cnt";
		close(CNT);
		&unlock;

		&load_page("$num_data");
	}
	else{
		&error("pwd");
	}
}

sub admin_ok {
	&get_conf;
	my $admin_pwd = crypt($FORM{'admin_pwd'}, "sp");
	if($CONF{'admin_pwd'} eq $admin_pwd) {
		print "Set-Cookie: ADMIN_PWD=$admin_pwd;\n"; 
		&select_func;
	}
	else {
		&error("pwd");
	}
}

sub select_func {
	&head("Ͻô ׸  ּ... ^.^");
	print <<__SEL_FUNC__;
		<br><br><br><br>
		<font class=ver9>  Ͽϴ.<p>
		ϴ ׸ Ͻð "LET'S GO!!!"ư ּ!</font>
		<form method=post action=$cgi_url>
		<select name=action>
			<option value=make_data selected> Ÿ </option>
			<option value=admin_conf> ȯ漳</option>
		</select>
		<input type=submit  value="LET'S GO!!!"   style='background-color:#FAFAFA;border:1 solid #333333;height:20'>
		</form>
		<br><br><br><br>
__SEL_FUNC__
	&foot;
}

sub make_data {
	&head("  Ÿ  ");
	
	print <<__MAKE_DATA__;
		<br><br><br><br>
		<script language="JavaScript">
		function sendit()
		{
			var str;
			
			str = document.make_data.title.value;
			if(str == ""){
				alert("  ּ...");
				document.make_data.title.focus();
				return true;
			}
			
			str = document.make_data.comment.value;
			if(str == ""){
				alert("   ּ...");
				document.make_data.comment.focus();
				return true;
			}


			document.make_data.submit();
			return true;
		}
		</script>
			<font color=#29487F>
			п     ּ... ^.^<br>
			</font>
			<br><br>
			<form method=post action=$cgi_url name=make_data onSubmit="sendit();return false">
			<input type=hidden name=action value=write_title>
			<div align=center>
			<table border=1 cellpadding=5 cellspacing=0 bgcolor=#29487F bordercolordark=white bordercolorlight=#29487F>
				<tr><td class=cont><font color=#ffffff> </font></td><td><input type=text name=title size=49></td></tr>
				<tr><td class=cont><font color=#ffffff> </font></td><td><textarea  name=comment cols=47 rows=7></textarea></td></tr>
				<tr><td>&nbsp;</td><td><input type=submit value="                        "></td></tr>
			</table>
			</div>
			</form>

__MAKE_DATA__

	&foot;
}

sub write_title {
	&read_cookie;
	&error("haker") if($COOKIE{'ADMIN_PWD'} ne $CONF{'admin_pwd'});
	my($num_data);	
	open(NUM, "$data_dir/num.txt");
	chomp($num_data = <NUM>);
	close(NUM);
	$num_data++;

	open(NUM, ">$data_dir/num.txt");
	print NUM "$num_data";
	close(NUM);
	
	mkdir("$data_dir/$num_data",0777);
	mkdir("$data_dir/$num_data/o",0777);
	mkdir("$data_dir/$num_data/x",0777);
	
	$FORM{'comment'} =~ s/\r?\n/<br>/g;
	&get_date;	
	open(TITLE, ">$data_dir/$num_data/title.txt");
	print TITLE "$FORM{'title'}|$FORM{'comment'}|$t_date";
	close(TITLE);

	&load_page("$num_data");
}

sub admin_conf {
	&head("̰ ȯ漳 ϴ Դϴ... ^.^");

	print <<__ADMIN_CONF__;
		<script language="JavaScript">
		function sendit()
		{
			var str;
			
			str1 = document.admin.pwd01.value;
			str2 = document.admin.pwd02.value;
			if(str1 != str2){
				alert("ֽ йȣ ġ ʽϴ...");
				document.admin.pwd01.focus();
				return true;
			}

			document.admin.submit();
			return true;
		}
		</script>	
		<br><br>
		<font color=darkblue>[    ȣ   ]</font>
		<form method=post action=$cgi_url name=admin onSubmit="sendit();return false">
		<input type=hidden name=action value=chg_conf>
		<div align=center>	
		<table border=1 cellpadding=5 cellspacing=0 bgcolor=orange bordercolordark=white bordercolorlight=red>
			<tr>
				<td width=88><font color=white>йȣ</font></td><td><input type=password name=pwd01 size=12>&nbsp; <font color=white>(ĭ ״ θ  йȣ )</font></td>
			</tr>
			<tr>
				<td width=88><font color=white>Ȯ </font></td><td><input type=password name=pwd02 size=12></td>
			</tr>
			<tr>
				<td width=88><font color=white> </font></td><td><input type=text name=bgcolor value="$CONF{'bgcolor'}" size=12></td>
			</tr>
			<tr>
				<td colspan=2 align=center><input type=submit value="    Ȯ        "></td>
			</tr>
		</table>
		</div>
		</form>



__ADMIN_CONF__
	&foot;
}

sub chg_conf {
	my($admin_pwd);
	&read_cookie;
	&error("haker") if($COOKIE{'ADMIN_PWD'} ne $CONF{'admin_pwd'});
	if($FORM{'pwd01'} ne "") {
		$admin_pwd = crypt($FORM{'pwd01'},"sp");
	}
	else{
		$admin_pwd = $CONF{'admin_pwd'};
	}
	open  (CONF, ">$data_dir/conf.cgi");
	print CONF "admin_pwd = $admin_pwd\n";
	print CONF "bgcolor = $FORM{'bgcolor'}\n";
	close (CONF);
	&get_conf;
	&input_pwd;
}

sub read_cookie{
    my(@cookies);
	if($ENV{'HTTP_COOKIE'}) {
		@cookies = split(/; /,$ENV{'HTTP_COOKIE'});
		foreach(@cookies) {
			my ($name,$value) = split(/=/,$_);
			$COOKIE{$name} = $value;
		}
	}
}

sub get_date {
  my ($sec,$min,$hour,$mday,$mon,$year,$wday) = (localtime)[0,1,2,3,4,5,6];
	$mon++;	
	$year += 1900;
	$date_val = sprintf("%04d/%02d/%02d [%02d:%02d]", $year,$mon, $mday, $hour, $min); 
	$t_date = substr($date_val,0,10);
}

sub error{
	my $input = shift;
	if($input eq "pwd"){
		$title = "йȣ ";
		$msg = "йȣ ߸Ǿϴ";
	}
	elsif($input eq "haker"){
		$title = "峭ġ ";
		$msg = " ĿԴϱ?<br><br> ϼ...";            
	}
	elsif($input eq "pass"){
		$title = "йȣġ ";
		$msg = "йȣ ġ ʽϴ...";               
	}
	
	&head("$title");
	print "<br><br><br><br><br>\n";
	print "<font color=#FF2F92 size=5>Error!!!</font><br><br>";
	print "$msg<br><br>\n";
	print "ٽѹ Ȯ .<br><br>" unless($input eq "haker");
	print "<a href=\"javascript:history.go(-1)\">{ B A C K }</a><br><br>";
	&foot;
}

sub tbl_up {
	print "<table width=100% height=90% border=0 cellpadding=3 cellspacing=0>\n";
	print "<tr>\n";
	print "<td valign=top align=center>\n";
}

sub tbl_down {
	print "</td>\n";
	print "</tr>\n";
	print "</table>\n";	
}

sub head{
	my $title = shift; 
	print "Content-type: text/html\n\n";
	print "<!---------------------------------------------------------------------------------->\n";
	print "<!--  Program Name - Sepal's SPOX v2.0                                          -->\n";
	print "<!--  Programer - Kim se youn (madgf\@hanmail.net, sepal\@spfamily.com)           -->\n";
	print "<!--  Homepage - http://sepal.woorizip.com or http://www.spfamily.com           -->\n";
	print "<!--  Last Modified - 2001.02.24                                                -->\n";
	print "<!--                                                          made in KOREA   -->\n";
	print "<!---------------------------------------------------------------------------------->\n\n";
	print "<html>\n";
	print "<head><title>ƢƢ $title ƢƢ</title>\n";
	print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=EUC-KR\">\n";
	print "<style type='text/css'>\n";
	print "<!--\n";
	print "A:link {color:#2259C2;font-size:9pt;text-decoration:none;}\n";
	print "A:visited {color:#2259C2;font-size:9pt;text-decoration:none;}\n";
	print "A:active {color:pink;font-size:9pt;text-decoration:underline;}\n";
	print "A:hover {color:#FF5E15;font-size:9pt;text-decoration:underline;}\n";
	print "p,br,body,select,input,form,textarea,option {font-size:9pt;font-family:;}\n";
	print "td {font-size:9pt;font-family:;}\n";
	print ".cont{line-height:140%}\n";
	print ".input{background-color:#F6F8FD;border:1 solid #2259C2;height:20}\n";
	print ".textarea{background-color:#F6F8FD;border:1 solid #2259C2}\n";
	print ".btn{color:#2259C2;background-color:#F6F8FD;border:1 solid #2259C2;height:20}\n";
	print "-->\n";
	print "</style>\n";
        print "<style>BODY{background-attachment: fixed; background-image: url(http://www.namjun.org/images/bg01.gif); background-repeat: no-repeat; background-position: bottom right; scrollbar-face-color: ffffff; scrollbar-shadow-color: 9bffcc; scrollbar-highlight-color: 9bffcc; scrollbar-3dlight-color: ffffff; scrollbar-darkshadow-color: black; scrollbar-track-color: ffffff; scrollbar-arrow-color: 9bffcc;}\n";
        print "</style>\n";
	print "</head>\n";
	$CONF{'bgcolor'} ||= "#ffffff";
	print "<body bgcolor=$CONF{'bgcolor'} topmargin=0 leftmargin=0>\n";
	print "<center>\n";
	&tbl_up;

	print <<__LOGO__;
		<br><br>
		<a href=$cgi_url?action=input_pwd><img src=$img_url/logo.gif border=0 alt="  "></a>
__LOGO__
}       

sub foot{
	&tbl_down;
	print "<br><a href=\"http://my.dreamwiz.com/manduk06\" target=\"_blank\"><font color=silver>ƢƢ Skin by H.S.H ƢƢ</font></a><br><br>\n" ;
	print "</center>\n";
	print "</body>\n";
	print "</html>\n";
	exit;
}

sub lock{
	my($lock_file, $lock_sec, $chk_cnt, $sleep_sec);
	
	$lock_file = "locking";
	$lock_sec = 2; #lockŴ ð()
	$chk_cnt = $lock_sec*10;
	$sleep_sec = 0.1;
	
	while ($chk_cnt--){
		if(-e "$data_dir/$num_data/$lock_file"){
			select (undef,undef,undef,$sleep_sec);
		}
		else{
			open (LOCK,">$data_dir/$num_data/$lock_file");
			close (LOCK);
			return 1;
		}
	}
	return 0;
}

sub unlock{
	my ($lock_file) = "locking";
	unlink ("$data_dir/$num_data/$lock_file");
}

exit;